<?php

// -------------------------------------------------------------------------- \\
// This is the main QuickFox 2 file                                           \\
//                                                       (c) LION 2007 - 2008 \\
// -------------------------------------------------------------------------- \\

// Simple InUSE Check
if ( !defined('QF_STARTED') )
        die('Hacking attempt');

if (defined('QF_FOX_STARTED'))
    die('Scripting error');

define('QF_FOX_STARTED', true);

define('QUICKFOX_DIR', dirname(__FILE__).'/');

// data directories constants
define('QF_INC_ROOT',    QF_DATA_ROOT.'includes/');
define('QF_MODULES_DIR', QF_DATA_ROOT.'modules/');
define('QF_PAGES_DIR',   QF_INC_ROOT.'pages/');
define('QF_SCRIPTS_DIR', QF_INC_ROOT.'scripts/');

// Defining some usefull constants
define('UNAME_MASK', '^[0-9\w_\+\-=\(\)\[\] ]{3,16}$');
define('QF_FOX2_SERVICE_PERIOD', 60);  // 1 minute service check period
define('QF_FOX2_RESULT_LIFETIME', 3600);
define('QF_FOX2_MAXULEVEL', 7);

define('QF_FOX2_URLTEMPS_CACHENAME', 'FOX2.URLTEMPS');
define('QF_FOX2_URLTEMPS_RW_CACHENAME', 'FOX2.RW_URLTEMPS');

class Fox2
{
    var $URL_temps;

    function Fox2()
    {
        global $QF;
        if ($CL_Config = qf_file_get_carray(QUICKFOX_DIR.'modules.qfc'))
        {
            foreach ($CL_Config as $mod => $cfg)
            {
                $cfg = explode('|', $cfg);
                if (isset($cfg[1]) && $cfg[1])
                    $QF->Register_Module($mod, QUICKFOX_DIR.trim($cfg[1]), trim($cfg[0]));
                else
                    $QF->Register_Module($mod, QUICKFOX_DIR.trim($cfg[0]));
            }
        }

    }

    function _Start()
    {
        global $QF;
        $GLOBALS['FOX'] =& $this;

        $QF->Timer->Time_Log('FOX2 module started');

        if ($QF->GPC->Get_Bin('drop_cache', QF_GPC_GET))
            $QF->Cache->Clear();

        $QF->LNG->Load_Language('common');

        // running the services
        $next_start = $QF->Config->Get('service_nextstart', 'temp');
        if ($next_start < $QF->Timer->time)
        {
            $QF->Run_Module('Services');
            $QF->Config->Set('service_nextstart', ($QF->Timer->time + QF_FOX2_RESULT_LIFETIME), 'temp', true);
        }

        // starting neded modules
        $QF->Run_Module('DSets');
        $QF->Run_Module('User');

        // registering extended modules
        if ($r_mods = $QF->DSets->Get_DSet('fox_modules'))
            foreach ($r_mods as $r_mod => $r_cfg)
            {
                $r_cfg = explode('|', $r_cfg);
                if (isset($r_cfg[1]) && $r_cfg[1])
                    $QF->Register_Module($r_mod, QF_MODULES_DIR.trim($r_cfg[1]), trim($r_cfg[0]));
                else
                    $QF->Register_Module($r_mod, QF_MODULES_DIR.trim($r_cfg[0]));
            }

        //$this->_Parse_PathInfo();

        if ($domain = $QF->Config->Get('cookie_domain'))
            $QF->HTTP->Set_Cookie_Domain($domain);

        $QF->Events->Set_On_Event('VIS_PreParse',  Array(&$this, 'On_VIS_Prep') );
        if ($rw_id = $QF->GPC->Get_String('rw_id', QF_GPC_GET, QF_STR_WORD))
        {
            $this->_Parse_RW($rw_id, $QF->GPC->Get_String('rw_data', QF_GPC_GET));
            $QF->Events->Set_On_Event('HTTP_HTML_parse', Array(&$this, '_HTML_FullURLs') );
            $QF->Events->Set_On_Event('HTML_block_parse', Array(&$this, '_HTML_FullURLs') );
        }

        // first try to determine if we are running a datapage
        if ($data_page = $QF->GPC->Get_String('sr', QF_GPC_GET, QF_STR_WORD))
            $this->Run_Data($data_page);

        // open session
        $QF->Session->Open_Session();
        if ($QF->Config->Get('sid_urls', 'session', true) && $QF->Config->Get('cookie_check', 'session') && $QF->Session->Get_Status(QF_SESSION_USEURL | QF_SESSION_LOADED) == QF_SESSION_USEURL)
            $QF->HTTP->Redirect($QF->HTTP->Request);

        // then try to determine if we are running an AJAX parser
        if ($aj_page = $QF->GPC->Get_String('aj', QF_GPC_GET, QF_STR_WORD))
            $QF->User->is_spider || $this->Run_AJAX($aj_page);

        // then try to run script if needed
        if ($script = $QF->GPC->Get_String('script', QF_GPC_POST, QF_STR_WORD))
            $QF->User->is_spider || $this->Run_Script($script);

        // if we don't need to run scripts or datapages we will draw a normal page
        $QF->Run_Module('VIS');
        $vis_style = $QF->Config->Get('vis_style', '', 'qf_def');
        $vis_style = explode('|', $vis_style);
        $QF->VIS->Configure(Array(
            'root_node' => 'GLOBAL_HTMLPAGE',
            'style' => $vis_style[0],
            'CSS' => (isset($vis_style[1])) ? $vis_style[1] : null,
            ), true);


        if ($QF->Config->Get('css_separate'))
        {
            $QF->VIS->Configure(Array('force_append' => false));
            $QF->VIS->Add_Data(0, 'META', '<link rel="stylesheet" type="text/css" href="'.$this->Gen_URL('fox2_css_data', $vis_style, true).'" />');
        }


        $QF->VIS->Set_VConsts(Array('MAXULEVEL' => QF_FOX2_MAXULEVEL));
        $QF->VIS->Load_Templates();

        $page = $QF->GPC->Get_String('st', QF_GPC_GET, QF_STR_WORD);

        if (!$page)
            $page = 'pages';

        $this->Show_Page($page);
    }

    function Run_Data($name)
    {
        global $QF;
        global $FOX;

        if (connection_aborted())
            trigger_error('FOX: connection was aborted at client side', E_USER_WARNING);
        if (($data = $QF->DSets->Get_DSet_Value('fox_datapages', $name)) && isset($data['module'], $data['method']))
        {
            $QF->Run_Module($data['module']);
            qf_func_call(Array(&$QF->$data['module'], $data['method']));
            trigger_error('FOX: datapage "'.$name.'" did not end execution by it\'s own', E_USER_NOTICE);
        }
        else
            trigger_error('FOX: there is no "'.$name.'" datapage data', E_USER_WARNING);

        header ($QF->HTTP->SERVER["SERVER_PROTOCOL"].' 501 Not Implemented');
        $QF->HTTP->Redirect(($QF->HTTP->Referer && !$QF->HTTP->ExtRef) ? $QF->HTTP->Referer : QF_INDEX);
    }

    function Run_AJAX($name)
    {
        global $QF;
        global $FOX;

        $AJAX_DATA = null;
        $AJAX_STATUS = 200;

        if (connection_aborted())
            trigger_error('FOX: connection was aborted at client side', E_USER_WARNING);
        elseif ($name == 'PING') // session pinger works
        {

        }
        elseif (($data = $QF->DSets->Get_DSet_Value('fox_ajax_scripts', $name)) && isset($data['module'], $data['method']))
        {
            $QF->Run_Module($data['module']);
            $AJAX_DATA = qf_func_call_ref(Array(&$QF->$data['module'], $data['method']), $AJAX_STATUS);
        }
        else
        {
            trigger_error('FOX: there is no "'.$name.'" AJAX parser file', E_USER_WARNING);
            $AJAX_STATUS = 404;
            $AJAX_DATA = 'Parser Not Found';
        }

        $AJAX_DATA = '{ status: '.intval($AJAX_STATUS).', data: '.qf_value_JS_definition($AJAX_DATA).' }';
        if ($QF->GPC->Get_String('AJMethod', QF_GPC_GET, QF_STR_WORD) == 'form')
        {
            $AJAX_ID = $QF->GPC->Get_String('AJID', QF_GPC_GET, QF_STR_WORD);
            $AJAX_DATA = 'top && top.QF_AJAX && top.QF_AJAX.Form_Ready(\''.$AJAX_ID.'\', '.$AJAX_DATA.' );';
            $AJAX_DATA = '<?xml version="1.0"?>
                <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
                <html xmlns="http://www.w3.org/1999/xhtml">
                <head><!--Meta-Content-Type--></head><body><script type="text/javascript">
                // JavaScript Starts Here <![CDATA[
                '.$AJAX_DATA.'
                //]]> JavaScript ends here
                </script></body></html>';
        }
        else
            $QF->HTTP->do_HTML = false;

        $QF->HTTP->Clear();
        $QF->HTTP->Write($AJAX_DATA);
        $QF->HTTP->Send_Buffer($QF->Session->Get('recode_out'));
    }

    function Run_Script($name)
    {
        global $QF;
        global $FOX;

        if (connection_aborted())
            trigger_error('FOX: connection was aborted at client side', E_USER_WARNING);
        elseif ($data = $QF->DSets->Get_DSet_Value('fox_scripts', $name))
        {
            Ignore_User_Abort(True);

            $result = false;

            if (isset($data['module'], $data['method']))
            {
                $QF->Run_Module($data['module']);
                $result = qf_func_call(Array(&$QF->$data['module'], $data['method']));
                if (!$result)
                {
                    trigger_error('FOX: script "'.$file.'" did not set result by it\'s own', E_USER_NOTICE);
                    $result = Array(Lang('SCR_FINISHED_NORES'));
                }
                elseif (!is_array($result))
                    $result = Array($result);
            }
            elseif (isset($data['include']) && ($file = QF_SCRIPTS_DIR.$data['include'].'.php') && file_exists($file))
            {
                include ($file);
                trigger_error('FOX: script-include "'.$file.'" did not end execution by it\'s own', E_USER_NOTICE);
                $result = Array(Lang('SCR_FINISHED_NORES'));
            }
            else
            {
                $result = Array(Lang('ERR_SCR_CODE_NOTFOUND'), '', true);
                trigger_error('FOX: there is no "'.$name.'" script data', E_USER_WARNING);
            }

            call_user_func_array(Array(&$this, 'Set_Result'), $result);
        }
        else
            trigger_error('FOX: there is no "'.$name.'" script data', E_USER_WARNING);
    }

    function Show_Page($pg)
    {
        global $QF;
        global $FOX;


        $QF->VIS->Add_Data_Array(0, Array(
            'SITE_NAME' => ($site_name = $QF->Config->Get('site_name')) ? htmlspecialchars($site_name) : 'QuickFox 2',
            ) );
        if ($adv = $QF->Config->Get('adv_data', 'visual'))
            $QF->VIS->Add_Data(0, 'ADV', $adv);


        if (($data = $QF->DSets->Get_DSet_Value('fox_pages', $pg)) && isset($data['module'], $data['method']))
        {
            $QF->Run_Module($data['module']);
            $p_subtitle = $p_title = '';
            $d_result = false;
            $pg_node = qf_func_call_arr(Array(&$QF->$data['module'], $data['method']), Array(&$p_title, &$p_subtitle, &$d_result));
            if ($pg_node)
                $QF->VIS->Append_Node($pg_node, 'PAGE_CONT', 0);
            if ($p_title)
                $QF->VIS->Add_Data(0, 'PAGE_TITLE', $p_title);
            if ($p_subtitle)
                $QF->VIS->Add_Data(0, 'PAGE_SUBTITLE', $p_subtitle);
            if ($d_result && is_array($d_result))
                call_user_method_array('Draw_Result', $this, $d_result);
        }
        elseif (($file = QF_PAGES_DIR.$pg.'_inc.php') && file_exists($file))
            include ($file);
        else
        {
            $this->Draw_Result(Lang('ERR_INCLUDE_LOAD'), ($QF->HTTP->Referer && !$QF->HTTP->ExtRef) ? $QF->HTTP->Referer : QF_INDEX, true);
            header ($QF->HTTP->SERVER["SERVER_PROTOCOL"].' 404 Not Found');
        }


        $this->Draw_menu();
        if ($QF->User->UID || ($QF->Config->Get('show_login_pan') && !$QF->User->is_spider))
            $this->Draw_Panel('login');


        // [check & debug stuff]
        // $QF->Run_Module('Parser');
        // $QF->Parser->Init_Std_Tags();
        // $QF->GPC->Recheck_Files();
        $QF->VIS->Add_Data_Array(0, Array(
            //'PAGE_CONT'  => $QF->Parser->Parse(' http://foxel.lionhvost.ru [quote=Хай]fdsfsd [/quote][*][table=3|1]he[b]llo[*][i]w[/b]orld[*] i [url=http://mail.ru][u]love you!![*][*]dd', 1),
            //'PAGE_CONT'  => qf_array_definition($QF->DBase->Do_Multitable_Select(Array('cms_pgs' => Array('fields' => Array('id'), 'prefix' => 't_'), 'cms_stats' => Array('fields' => '*', 'where' => Array('id' => 'index'))), '', QF_SQL_SELECTALL)),
            //'PAGE_CONT'  => qf_array_definition($QF->DBase->history),
            //'PAGE_CONT'  => nl2br(qf_array_definition(get_extension_funcs("gd"))).decbin(imagetypes()).phpversion('gd2'),
            //'PAGE_CONT'  => $QF->HTTP->Request,
            //'PAGE_CONT'  => qf_array_definition(get_loaded_extensions()),
            //'PAGE_CONT'  => htmlspecialchars($QF->Parser->XML_Check('<table style="<ref"><tr><td colspan=2><<td>fae<td>fdwe&&nbsp;<br></table>', true)),
            ) );
        //$QF->VIS->Add_Data(0, 'JS', qf_file_get_contents('ajax.js'));
        // [/check & debug stuff]

        if ($recode = $QF->GPC->Get_String('recode', QF_GPC_GET, QF_STR_WORD))
            $QF->Session->Set('recode_out', $recode);
        elseif ($recode !== null)
            $QF->Session->Drop('recode_out');

        $QF->HTTP->Clear();
        $QF->HTTP->Write($QF->VIS->Make_HTML());
        $QF->HTTP->Send_Buffer($QF->Session->Get('recode_out'));
    }

    function Draw_Menu()
    {
        global $QF;
        $menubts = $QF->Config->Get('menu_buttons', 'visual');
        $cur_butt = false;
        if (is_array($menubts))
            foreach ($menubts as $butt)
                if (is_array($butt) && qf_str_is_url($butt['url']))
                {
                    $butt['url'] = qf_full_url($butt['url']);
                    if (isset($butt['is_sub']) && $butt['is_sub'] && $cur_butt)
                        $QF->VIS->Add_Node('MENU_SUBBUTTON', 'SUBS', $cur_butt, qf_value_htmlschars($butt));
                    else
                        $cur_butt = $QF->VIS->Add_Node('MENU_BUTTON', 'MENU_ITEMS', 0, qf_value_htmlschars($butt));
                }
    }

    function Draw_Panel($name)
    {
        global $QF;
        global $FOX;


        if (($data = $QF->DSets->Get_DSet_Value('fox_panels', $name)) && isset($data['module'], $data['method']))
        {
            $CUR_PANEL = $QF->VIS->Add_Node('PANEL_BODY', 'PANELS', 0, false, $name.'_panel');
            $QF->Run_Module($data['module']);
            qf_func_call(Array(&$QF->$data['module'], $data['method']), $CUR_PANEL);
            return true;
        }
        else
            return false;
    }

    function Set_Result($text, $redir_to = '', $is_err = false, $code = '')
    {
        global $QF;

        $res_id = qf_short_uid('res');

        $QF->DBase->Do_Delete('results', 'WHERE time < '.($QF->Timer->time - QF_FOX2_RESULT_LIFETIME));
        if (!$QF->Session->SID)
            $QF->Session->Open_Session();
        $ins_data = Array(
            'res_id'   => $res_id,
            'code'     => $code,
            'text'     => (string) $text,
            'is_err'   => ($is_err) ? 1 : 0,
            'time'     => $QF->Timer->time,
            'got_at'   => $QF->HTTP->Request,
            'redir_to' => $redir_to,
            'u_sid'    => $QF->Session->SID,
            'u_id'     => $QF->User->UID,
            );

        if ($QF->DBase->Do_Insert('results', $ins_data))
            $QF->HTTP->Redirect($this->Gen_URL('fox2_showresult_page', Array($res_id)));
        else
        {
            trigger_error('FOX: error setting result data', E_USER_WARNING);
            // if user must be regirected we'll try do this without setting result data
            if ($redir_to)
                $QF->HTTP->Redirect($redir_to);
        }

    }

    function Draw_Result($text, $redir_to = '', $is_err = false)
    {
        global $QF, $FOX;

        $hurl = '';

        if ($redir_to)
        {
            $url = qf_full_url($redir_to);
            $QF->Events->Call_Event_Ref('HTTP_URL_Parse', $url );
            $hurl = strtr($url, Array('&' => '&amp;'));

            header('Refresh: 7; URL="'.$url.'"');
        }

        $QF->VIS->Add_Node('FOX_RESULT_WINDOW', 'PAGE_CONT', 0, Array(
            'text'    => $text,
            'is_err'  => ($is_err) ? 1 : null,
            'redir_url' => $hurl,
            ) );
        $QF->VIS->Add_Data(0, 'PAGE_TITLE', ($is_err) ? Lang('RES_CAPT_ERR') : Lang('RES_CAPT'));
    }

    function Log_Event($event, $log_name = 'common')
    {
        global $QF;
        $log_name = substr(preg_replace('#\W#', '_', $log_name), 0, 32);
        $ins_data = Array(
            'log_id'    => $log_name,
            'time'      => $QF->Timer->time,
            'event'     => $event,
            'cl_ip'     => $QF->HTTP->IP_int,
            'cl_req'    => $QF->HTTP->Request,
            'cl_uagent' => $QF->HTTP->UAgent,
            );
        return $QF->DBase->Do_Insert('fox_logs', $ins_data);
    }

    function Gen_URL($url_id, $params = Array(), $with_amps = false, $no_enc = false)
    {
        global $QF;
        static $vars;
        if (!$vars)
            $vars = Array(
                '{QF_SID}' => $QF->Session->SID,
                );

        if (!is_array($params))
            $params = Array($params);
        if (!$url_id)
            return QF_INDEX;

        $url_id = strtoupper($url_id);

        if (!is_array($this->URL_temps))
            $this->_Load_URLS();

        if (isset($this->URL_temps[$url_id]))
        {
            $string = strtr($this->URL_temps[$url_id], $vars);
            $count = count(explode('%', $string));
            while (count($params) < $count)
                $params[] = '';

            if (!$no_enc)
                $params = qf_array_parse($params, 'qf_url_encode_part');
            $string = qf_sprintf_arr($string, $params);
            $string = ($with_amps) ? preg_replace('#\&(?![A-z]+;)#', '&amp;', $string) : str_replace('&amp;', '&', $string);
            return $string;
        }
        else
            return '#';
    }

    function On_VIS_Prep(&$indata)
    {
        if (!is_array($this->URL_temps))
            $this->_Load_URLS();

        $indata = preg_replace_callback('#\{(?>(F)?URL:((?:\w+|\"[^\"]+\"|\|)+))\}#',Array(&$this, '_VISParse_URL_CB'),$indata);
    }

    function _VISParse_URL_CB($matches)
    {
        $code = $matches[2];
        $code = explode('|', $code);

        if (!($url_id = strtoupper($code[0])))
            return '#';
        if (!isset($this->URL_temps[$url_id]))
            return '#';

        if ($params = array_slice($code, 1))
        {
        	foreach ($params as $id => $val)
                $params[$id] = (is_numeric($val{0})) ? (int) $val : (($val{0} == '"') ? rawurlencode(substr($val, 1, -1)) : '{URLEN:'.$val.'}');
        }
        else
            $params = Array();

        $url = $this->Gen_URL($url_id, $params, true, true);
        if ($matches[1] == 'F')
            $url = qf_full_url($url, true);
        return $url;
    }

    function _Load_URLS()
    {
        global $QF;
        static $consts = Array(
            '{QF_INDEX}' => QF_INDEX,
            );


        if (count($this->URL_temps))
            return false;

        $cachename = ($QF->Config->Get('gen_rwurls'))
            ? QF_FOX2_URLTEMPS_RW_CACHENAME : QF_FOX2_URLTEMPS_CACHENAME;

        if ($data = $QF->Cache->Get($cachename))
            $this->URL_temps = $data;
        elseif (list($data, $pkgs) = $QF->DSets->Get_DSet('urltemplates', true))
        {
            if ($QF->Config->Get('gen_rwurls') && ($rwdata = $QF->DSets->Get_DSet('mod_rw_urlts')))
                $data = $rwdata + $data;

            if ($QF->Config->Get('tgl_multidomain', 'fox2') && ($domains = $QF->Config->Get('package_domains', 'fox2')) && is_array($domains))
            {
                $domains = preg_replace('#^http\:(?:/)*|/$#i', '', $domains);

                $consts['{QF_INDEX}'] = QF_INDEX;
                $cur_pckg = false;
                foreach ($data as $key => $val)
                {
                    if (count($domains) && $cur_pkg != $pkgs[$key])    // we need to check if there is a domain name attached to the pachage
                    {
                        $cur_pkg = $pkgs[$key];
                        if (isset($domains[$cur_pkg]))
                        {
                            $domain = $domains[$cur_pkg];
                            $consts['{QF_INDEX}'] = 'http://'.$domain.'/'.QF_INDEX;
                        }
                        else
                            $consts['{QF_INDEX}'] = QF_INDEX;
                    }
                    $val = str_replace(array_keys($consts), array_values($consts), $val);
                    $data[$key] = $val;
                }
            }
            else
                $data = str_replace(array_keys($consts), array_values($consts), $data);

            $QF->Cache->Set($cachename, $data);
            $this->URL_temps = $data;
        }
        else
            $this->URL_temps = Array();

        return true;
    }

    function _Parse_PathInfo()
    {
        global $QF;
        if (!($pt_info = $QF->HTTP->PtInfo))
            return false;

        $pt_info = explode('/', $pt_info);
        $pt_id   = $pt_info[0];
        $pt_parse = $QF->DSets->Get_DSet_Value('ptinfo_masks', $pt_id);
        if (is_array($pt_parse))
        {
            $pt_parse = array_values($pt_parse);
            $pt_data = Array();
            $imax = min(count($pt_parse), count($pt_info));
            for ($i=0; $i<$imax; $i++)
                $pt_data[$pt_parse[$i]] = $pt_info[$i];

            trigger_error(qf_array_definition($pt_data), E_USER_WARNING);

            $QF->GPC->Set_Raws($pt_data, QF_GPC_GET);
        }
    }


    function _Parse_RW($rw_id, $rw_data)
    {
        global $QF;

        if (!$rw_id)
            return false;

        $rw_mask = $QF->DSets->Get_DSet_Value('RW_masks', $rw_id);
        $rw_data = preg_replace('#\.\w*$#D', '', $rw_data);

        if (!$rw_mask)
        {
            $QF->GPC->Set_Raws(Array('st' => $rw_id, 'dpath' => $rw_data), QF_GPC_GET);
        }
        elseif (is_array($rw_mask))
        {
            $rw_data = explode('/', $rw_data);
            $rw_mask = preg_replace('#\$(\d+)#e', '(isset(\$rw_data[\1])) ? \$rw_data[\1] : ""', $rw_mask);

            $QF->GPC->Set_Raws($rw_mask, QF_GPC_GET);
        }
        else
            return false;

        return true;
    }

    function _HTML_FullURLs(&$buffer)
    {
        $buffer = preg_replace_callback('#(<(a|form|img|link)\s+[^>]*)(href|action|src)\s*=\s*(\"([^\"<>\(\)]*)\"|\'([^\'<>\(\)]*)\'|[^\s<>\(\)]+)#i', Array(&$this, '_FullURLs_Parse_Callback'), $buffer);
    }

    function _FullURLs_Parse_Callback($vars)
    {
        Global $QF;
        if (!is_array($vars))
            return false;

        if (isset($vars[6]))
        {
            $url = $vars[6];
            $bounds = '\'';
        }
        elseif (isset($vars[5]))
        {
            $url = $vars[5];
            $bounds = '"';
        }
        else
        {
            $url = $vars[4];
            $bounds = '';
        }

        if (qf_str_is_url($url) == 2)
            $url = qf_full_url($url, true);

        return $vars[1].$vars[3].' = '.$bounds.$url.$bounds;

    }

}

$QF->Register_Module('FOX', __FILE__, 'Fox2');
$QF->Run_Module('FOX');

?>
